#ifndef __G3API__
#define __G3API__

#include "windows.h"

// WR G3 API exported functions

#define CALLCONV __stdcall

#pragma pack(1)

typedef struct {
	DWORD bLength;
	char szSerNum[9];
	char szProdName[9];
	unsigned __int64 MinFreq;
	unsigned __int64 MaxFreq;
	struct {
		DWORD ExtRef:1;
		DWORD FMWEnabled:1;
		DWORD Reserved:30;
		} Features;
	} RADIO_INFO2;

#pragma pack()

typedef int (CALLCONV *TGetRadioList)(RADIO_INFO2 *lpRadioInfo,int BufferSize,DWORD *InfoSize);
typedef int (CALLCONV *TOpen)(char *ID);
typedef int (CALLCONV *TOpenRadioDevice)(int index);
typedef BOOL (CALLCONV  *TCloseRadioDevice)(int rHandle);
typedef BOOL (CALLCONV  *TSetFrequency)(int hRadio, int dwFreq);
typedef BOOL (CALLCONV  *TSetAtten)(int hRadio, BOOL fAtten);
typedef BOOL (CALLCONV  *TSetPower)(int hRadio, BOOL fPower);
typedef BOOL (CALLCONV  *TSetAGC)(int hRadio, int iAGC);
typedef BOOL (CALLCONV  *TSetIFGain)(int hRadio, int iIFGain);
typedef int (CALLCONV  *TGetFrequency)(int hRadio);
typedef BOOL (CALLCONV  *TGetAtten)(int hRadio);
typedef BOOL (CALLCONV  *TGetPower)(int hRadio);
typedef int (CALLCONV  *TGetAGC)(int hRadio);
typedef int (CALLCONV  *TGetIFGain)(int hRadio);
typedef int (CALLCONV  *TGetRawSignalStrength)(int hRadio);

typedef BOOL (CALLCONV *TBlockScan)(int hRadio,int *Freqs, int Count,int StopSquelch,DWORD FeedbackTime,HWND WinHandle,DWORD Msg);
typedef BOOL (CALLCONV *TStopBlockScan)(int hRadio);
typedef BOOL (CALLCONV *TPauseBlockScan)(int hRadio);
typedef BOOL (CALLCONV *TResumeBlockScan)(int hRadio);
typedef int (CALLCONV  *TGetLastRawSS)(int hRadio);
typedef DWORD (CALLCONV *TGetInternalRSSI)(int hRadio);
typedef BOOL (CALLCONV  *TG3IsBusy)(int hRadio);

typedef BOOL (CALLCONV  *TG3GetInfo)(int hRadio,RADIO_INFO2 *info);

typedef BOOL (CALLCONV *TSetRefClock)(int hRadio, DWORD RefClock);
typedef BOOL (CALLCONV *TSetFreqAsync)(int hRadio, DWORD freq);
typedef BOOL (CALLCONV *TWaitFreqAsync)(int hRadio);

typedef DWORD (CALLCONV *TGetRefClock)(int hRadio);

typedef DWORD (CALLCONV *TIsDeviceConnected)(int hRadio);

typedef BOOL (CALLCONV *TSetRFamp)(int hRadio,BOOL fRFamp);
typedef BOOL (CALLCONV *TGetRFamp)(int hRadio);

typedef int (__stdcall *TGetTuneError)(int hRadio);

typedef int (CALLCONV *TSetFreqPipelined)(int hRadio,DWORD Freq,BOOL IsFirst,LONG Settling);
typedef int (CALLCONV *TGetSSPipeLined)(int hRadio,int *SS,BYTE *rawSS,int *RSSI, int *AGC);

typedef int (CALLCONV *TGetIF2Frequency)(int hRadio);
typedef BOOL (CALLCONV *TSetIF2Frequency)(int hRadio,int freq);

typedef BOOL (CALLCONV *TSetLEDFlashPattern)(int hRadio,BYTE blink); 

typedef BOOL (CALLCONV *TIsUSVersion)(int hRadio);
typedef DWORD (CALLCONV *TGetLock)(int hRadio,int GetType);

typedef char* (CALLCONV *TGetPath2)(int hRadio);
typedef BOOL (CALLCONV *TGetPath)(int hRadio,char *Pathname,size_t size);


#endif
